//-----------------------------------------
// LScript Modeler template
//
//Copyright Mike Green
// dodgy@shortbutpurple.fsnet.co.uk
//

@version 2.2
@warnings
@script modeler
@name MGUVRelax

// global values go here
myversion=1.3;

//v1.3
// got rid of annoying requester. Yay!

//1.2
// No longer need to deselect the morph map. 

// 1.1
// much faster now, still need to figure out how to deselect the morph! 

// 0.9
// need to figure out how to deselect the morph!
myuvmap;

main
{
    // requester code goes here
    myuvmap=VMap(VMTEXTURE,0) || error("Please choose a UV map");
    
    mystrength=recall("MGUVSmoothStrength",1.0);
    myiterations=recall("MGUVSmoothIterations",100);

    reqbegin("MG UV Relax Ver:"+myversion);
    t0 = ctltext("Note:","This does NOT affect discontinuous UVs and ");
    t1 = ctltext("","points adjoining DC UVs may be adversely affected");
    t2 = ctltext("BUT","All other points should be fine.");
    c0 = ctlnumber("Strength",mystrength);
    c1 = ctlminislider("Iterations",myiterations,1,1000);

    return if !reqpost();

    // get requester control values here
    mystrength=getvalue(c0);
    myiterations=getvalue(c1);

    store("MGUVSmoothStrength",mystrength);
    store("MGUVSmoothIterations",myiterations);

    reqend();

    // processing code goes here
//debug();

//    map=VMap();
//    selectvmap(VMMORPH,map.name)
//    selectvmap(VMMORPH,"");
//    selectvmap(VMTEXTURE,myuvmap.name);
    uvrelax(myiterations,mystrength);

}



uvrelax:myiterations,mystrength
{
    selmode(USER);
    mymesh=Mesh(0);
    
    editbegin();
        mypoints=points;
    editend();
    selpoint(SET,CONNECT);
    editbegin();
        moninit(points.size(),"Smoothing..");
        mymorph=VMap(VMSPOT,myuvmap.name+"_MGUVSmooth",3);
        foreach(p,points)
        {
            monstep();
            if(myuvmap.isMapped(p))
            {
                mypos=myuvmap.getValue(p);
                mymorph.setValue(p,<mypos[1], mypos[2],0>);
            }
        }
        monend();
    editend();

    selpoint(CLEAR);
    selpoint(SET,POINTID,mypoints);
    smooth(myiterations*10,mystrength);

//debug();
    selpoint(SET,CONNECT);
    editbegin();
        moninit(points.size(),"Clean up"); // add *2

        foreach(p,points)  // change to mypoints
        {
            monstep();
            if(mymorph.isMapped(p))
            {
                myuv=mymorph.getValue(p);
                myuvmap.setValue(p, myuv);          // doesn't seem to screw up discontinuous maps! 
                mymorph.setValue(p,nil);            // put this in here to make it faster
                                                  
            }
        }

        monend();
    editend();


    editbegin();
        mytemp = VMap(VMMORPH,"MGUVRelaxTempMorph",3);
        mytemp.setValue(points[1],<1,1,1>);
    editend();
    undo();

//    new();
//    close();

    mymesh.select();
    selectvmap(VMTEXTURE,myuvmap.name);

    selpoint(CLEAR);
    selpoint(SET,POINTID,mypoints);


}








